﻿Imports DayPilot.Web.Mvc
Imports DayPilot.Web.Mvc.Events.Scheduler

Namespace TutorialVB
    Public Class SchedulerController
        Inherits System.Web.Mvc.Controller

        '
        ' GET: /Scheduler

        Function Backend() As ActionResult
            Return New Dps().CallBack(Me)
        End Function

        Public Class Dps
            Inherits DayPilotScheduler

            Protected Overrides Sub OnInit(ByVal e As InitArgs)
                Resources.Add("Room A", "A")
                Resources.Add("Room B", "B")
                Resources.Add("Room C", "C")
                Resources.Add("Room D", "D")
                Resources.Add("Room E", "E")
                UpdateWithMessage("Welcome!", Enums.CallBackUpdateType.Full)
            End Sub

            Protected Overrides Sub OnTimeRangeSelected(ByVal e As TimeRangeSelectedArgs)
                Dim em = New EventManager()
                em.EventCreate(e.Start, e.End, "New event", e.Resource)
                UpdateWithMessage("A new event was created.")
            End Sub

            Protected Overrides Sub OnEventMove(ByVal e As EventMoveArgs)
                Dim em = New EventManager()
                em.EventMove(e.Id, e.NewStart, e.NewEnd, e.NewResource)
                UpdateWithMessage("The event was moved.")
            End Sub

            Protected Overrides Sub OnEventResize(ByVal e As EventResizeArgs)
                Dim em = New EventManager()
                em.EventMove(e.Id, e.NewStart, e.NewEnd, e.Resource)
                UpdateWithMessage("The event was resized.")
            End Sub


            Protected Overrides Sub OnFinish()
                REM update was not requested in the event handler using Update() or UpdateWithMessage()
                REM skip event reloading
                If UpdateType = Enums.CallBackUpdateType.None Then
                    Return
                End If

                Dim em = New EventManager()
                Events = em.FilteredData(StartDate, StartDate.AddDays(Days)).AsEnumerable

                DataStartField = "eventstart"
                DataEndField = "eventend"
                DataTextField = "name"
                DataIdField = "id"
                DataResourceField = "resource"
            End Sub

        End Class


    End Class
End Namespace
